#include <nds.h>
	#include "protos.h"

void DrawGLScene(void)
{
	u8 x, y;
	v16 hauteur, fixedX, fixedY, xText, yText, hText, sDiv;
	faces = 0;
	
	
	glLoadIdentity();
	gluLookAtf32(	joueur.posX, joueur.hauteur, joueur.posY, //position 
						joueur.posX + (MY_COS(joueur.angle) * MY_COS(joueur.view) / 4096), 
						MY_SIN(joueur.view), 
						joueur.posY + (MY_SIN(joueur.angle) * MY_COS(joueur.view) / 4096), //objectif
					inttof32(0), inttof32(1), inttof32(0)); //verticale
	
	
	for(y = 0; y < carte.sY; y++)
	{
		for(x = 0; x < carte.sX; x++)
		{
			hauteur = carte.map[y * carte.sX + x] * carte.cubeSize;
			fixedX = x * carte.cubeSize;
			fixedY = y * carte.cubeSize;
			
			
			if(hauteur < 14 * carte.cubeSize)
			{
				glBindTexture(GL_TEXTURE_2D, texture[0]);
				
				sDiv = 2048 / 4;
				xText = sDiv * (x % 4);
				yText = sDiv * (y % 4);
				
				glBegin(GL_QUADS);
					glTexCoord2t16(xText, yText + sDiv);			glVertex3v16(fixedX,			hauteur,	fixedY + carte.cubeSize);
					glTexCoord2t16(xText + sDiv, yText + sDiv);		glVertex3v16(fixedX + carte.cubeSize,	hauteur,	fixedY + carte.cubeSize);
					glTexCoord2t16(xText + sDiv, yText);			glVertex3v16(fixedX + carte.cubeSize,	hauteur,	fixedY);
					glTexCoord2t16(xText, yText);					glVertex3v16(fixedX,			hauteur,	fixedY);
				glEnd();
				
				faces++;
			}
			
			if(hauteur > 0)
			{
				glBindTexture(GL_TEXTURE_2D, texture[1]);
				
				sDiv = 2048 / 4;
				xText = sDiv * (x % 4);
				yText = sDiv * (y % 4);
				hText = carte.map[y * carte.sX + x] * sDiv;
				
				glBegin(GL_QUADS);
					if(y > 0 && carte.map[(y - 1) * carte.sX + x] < carte.map[y * carte.sX + x])
					{
						glTexCoord2t16(xText, hText);			glVertex3v16(fixedX,			hauteur,	fixedY);
						glTexCoord2t16(xText + sDiv, hText);	glVertex3v16(fixedX + carte.cubeSize,	hauteur,	fixedY);
						glTexCoord2t16(xText + sDiv, 0);		glVertex3v16(fixedX + carte.cubeSize,	0,			fixedY);
						glTexCoord2t16(xText, 0);				glVertex3v16(fixedX,			0,			fixedY);
				
						faces++;
					}
					if(x > 0 && carte.map[y * carte.sX + (x - 1)] < carte.map[y * carte.sX + x])
					{
						glTexCoord2t16(yText + sDiv, hText);	glVertex3v16(fixedX,	hauteur,	fixedY + carte.cubeSize);
						glTexCoord2t16(yText, hText);			glVertex3v16(fixedX,	hauteur,	fixedY);
						glTexCoord2t16(yText, 0);				glVertex3v16(fixedX,	0,			fixedY);
						glTexCoord2t16(yText + sDiv, 0);		glVertex3v16(fixedX,	0,			fixedY + carte.cubeSize);
				
						faces++;
					}
					if(y < carte.sY - 1 && carte.map[(y + 1) * carte.sX + x] < carte.map[y * carte.sX + x])
					{
						glTexCoord2t16(xText + sDiv, hText);	glVertex3v16(fixedX + carte.cubeSize,	hauteur,	fixedY + carte.cubeSize);
						glTexCoord2t16(xText, hText);			glVertex3v16(fixedX,			hauteur,	fixedY + carte.cubeSize);
						glTexCoord2t16(xText, 0);				glVertex3v16(fixedX,			0,			fixedY + carte.cubeSize);
						glTexCoord2t16(xText + sDiv, 0);		glVertex3v16(fixedX + carte.cubeSize,	0,			fixedY + carte.cubeSize);
				
						faces++;
					}
					if(x < carte.sX - 1 && carte.map[y * carte.sX + (x + 1)] < carte.map[y * carte.sX + x])
					{
						glTexCoord2t16(yText, hText);			glVertex3v16(fixedX + carte.cubeSize,	hauteur,	fixedY);
						glTexCoord2t16(yText + sDiv, hText);	glVertex3v16(fixedX + carte.cubeSize,	hauteur,	fixedY + carte.cubeSize);
						glTexCoord2t16(yText + sDiv, 0);		glVertex3v16(fixedX + carte.cubeSize,	0,			fixedY + carte.cubeSize);
						glTexCoord2t16(yText , 0);				glVertex3v16(fixedX + carte.cubeSize,	0,			fixedY);
				
						faces++;
					}
				glEnd();
			}
		}
	}
}


void drawBitmap(u16* src, u16 posX, u16 posY, u16 sX, u16 sY, int start, u16 trans)
{
	int x, y;
	for(y = 0; y < sY; y++)
	{
		for(x = 0; x < sX; x++)
		{
			if(src[y * sX + x + start] != trans)
				BG_GFX[(y + posY) * 256 + x + posX] = src[y * sX + x + start] | BIT(15);
			else
				BG_GFX[(y + posY) * 256 + x + posX] = 0;
		}
	}
}

